function [connected_regions,label,numregions]=Canny2(img)
bw_img=Bw_Canny(im2double(img));
    [descriptors,label,numregions]=fdesc2(bw_img,400);
   connected_regions=Recognize_pcs(descriptors,label,numregions);
   title('canny')
function bw_img_canny=Bw_Canny(img)

%%% This function calculates a binary image "bw_img_canny" from a double color image "img"
%%%using Canny edge detection and imfill 

%% Detect Green and Red squares using ratios of Red/Green and set them to
%%% white color
% valr=1;   
% img=filter_background(img,squares,buffer,valr);
% red=img(:,:,1)-img(:,:,2)-img(:,:,3);   red=im2bw(red,graythresh(red));
% img(repmat(red,1,1,3))=valr; clear red
% green=img(:,:,2)-img(:,:,1)-img(:,:,3); green=im2bw(green,graythresh(green));
% img(repmat(green,1,1,3))=valr; clear green
% white=img(:,:,3)-img(:,:,1);  white=im2bw(white,graythresh(white));
% img(repmat(white,1,1,3))=valr; clear white
%     figure;imshow(img);
%% 
gray_img=rgb2gray(img);
%%%erode gray_img with cross to remove the grid lines of the board
length = 9;
NHOOD = zeros(length);  NHOOD(ceil(length/2), :) = 1;   NHOOD(:, ceil(length/2)) = 1;
w = strel('arbitrary', NHOOD);
gray_img=imerode(imdilate(gray_img,w),w);
%            figure;imshow(gray_img);
%%%calculate edges using Canny edge detector
edge_img=edge(gray_img.^0.5,'canny',[0.05 0.2],1);
%           figure;imshow(edge_img);hold on
%%%Detect linish structures using hough_trans function and black them out
% coor=hough_trans(edge_img);
% mask=zeros(size(edge_img,1),size(edge_img,2));
%            figure;imshow(edge_img);hold on
% for i=1:numel(coor)
%     for j=1:numel(coor(i).x)
%          xc=coor(i).x(j); yc=coor(i).y(j);
% %         plot(coor(i).x,coor(i).y,'y-');
% %         hold on
%         mask(round(yc),round(xc))=1;
%     end
% end
%            figure;imshow(mask);
% %%%dilate mask to avoid approximations in line pixels positions
% mask=1-imdilate(mask,ones(9));
%            figure;imshow(mask);
% %%black lines out
% edge_img=double(edge_img).*mask;
%            figure;imshow(edge_img);
%%dilate edge image to make edges closed contours
w=strel('square',3);
edge_img=imdilate(edge_img,w);
          figure;imshow(edge_img);
%%%fill holes to get binary chess pieces
bw_img_canny=imfill(edge_img,'holes');
          figure;imshow(bw_img_canny); title('canny')
[L,n]=bwlabel(bw_img_canny);
%           figure;imshow(label2rgb(L));
for i=1:n
    if numel(L(L==i))<15000
                bw_img_canny(L==i)=0;

    end
   
end
%           figure;imshow(bw_img_canny);
% length = 15;
% NHOOD = zeros(length);  NHOOD(ceil(length/2), :) = 1;   NHOOD(:, ceil(length/2)) = 1;
% w = strel('arbitrary', NHOOD);
% bw_img_canny=imdilate(imerode(bw_img_canny,w),w);
%          figure;imshow(bw_img_canny);title('canny')
end
end