function [connected_regions,labels,numregions]=color_detection2(img)
map=Detect_pcs(img);
[descriptors,labels,numregions]=fdesc2(map,400);
 connected_regions=Recognize_pcs(descriptors,labels,numregions);
 title('color detection')
end
function map=Detect_pcs(img)

%%% Usage: This function detects the brown chess pieces in an input image
%%% input: uint8 color image "img"
%%% output: logical image brown_map showing locations of brown pieces

%% load color_training_LUTs
%load color_LUT
%  valr=255;   
% img=filter_background(img,squares,buffer,valr);
% red=img(:,:,1)-img(:,:,2)-img(:,:,3);   red=im2bw(red,graythresh(red));
% img(repmat(red,1,1,3))=valr; clear red
% green=img(:,:,2)-img(:,:,1)-img(:,:,3); green=im2bw(green,graythresh(green));
% img(repmat(green,1,1,3))=valr; clear green
% white=img(:,:,3)-img(:,:,1);  white=im2bw(white,graythresh(white));
% img(repmat(white,1,1,3))=valr; clear white
%     figure;imshow(img);
    pcs=img(:,:,1)<=230 & img(:,:,2)<230;
[row,col,dep]=size(img);
map=zeros(row,col);
map(pcs)=1;
% Rbin=floor(double(img(:,:,1))/BinSize)+1;
% Gbin=floor(double(img(:,:,2))/BinSize)+1;
% Bbin=floor(double(img(:,:,3))/BinSize)+1;
% 
%  for i=1:row
%      for j=1:col
%          if (brown_LUT(Rbin(i,j),Gbin(i,j),Bbin(i,j))==1 ||  baige_LUT(Rbin(i,j),Gbin(i,j),Bbin(i,j))==1)
%              map(i,j)=1;
%          end
%      end
%  end
%         figure;imshow(map); title('color detection')
 length = 9;
NHOOD = zeros(length);  NHOOD(ceil(length/2), :) = 1;   NHOOD(:, ceil(length/2)) = 1;
w = strel('arbitrary', NHOOD);
map=imdilate(imerode(map,w),w);
%           figure;imshow(map);
[L,n]=bwlabel(map);
%           figure;imshow(label2rgb(L));
for i=1:n
    if numel(L(L==i))<1000;
        map(L==i)=0;
    end
end
%         figure;imshow(map)
 map=imfill(map,'holes');
         figure;imshow(map); title('color detection');
end

