function display_board2(squares)

% load all icon images into a structure
class = {'G', 'Q', 'B', 'K', 'R', 'P'};
color = {'white', 'black'};
icons = struct('label', [], 'img', []);
backgnd={'r','g'};
ind = 1;
for ibackgnd=1:2
for icolor = 1:2
    for iclass = 1:numel(class)
        icons(ind).label = [color{icolor},'_',class{iclass},'_',backgnd{ibackgnd}];
        icon_fname = [color{icolor},'_',class{iclass},'_',backgnd{ibackgnd},'.jpg'];
        icons(ind).img = imread(fullfile('icons', icon_fname));
        ind = ind + 1;
    end
end
end
all_labels = {icons(:).label}';

% initialize blank board image
board = uint8(zeros(8*62+2,8*62+2,3));
board(1:62:8*62+1, :) = 0;
board(:, 1:62:8*62+1,:) = 0;
% loop through array of squares and add in icons
for irow = 1:8
    row_inds = (irow-1)*62 + (3:62);
    for icol = 1:8
        col_inds = (icol-1)*62 + (3:62);
        squarekolor=squares(9-irow,icol).color;
        if (squarekolor=='r')
            board(row_inds,col_inds,1)=255;
        elseif (squarekolor=='g')
             board(row_inds,col_inds,2)=255;   
        end
        class = squares(9-irow, icol).class;
        if ~isempty(class)
            occupancy = squares(9-irow, icol).occupancy;
            label = [occupancy,'_',class,'_',squarekolor];
            ind = strcmp(label, all_labels);
            [row,col,dep]=size(icons(ind).img);
            middlerow=10+(irow-1)*62;
            middlecol=10+(icol-1)*62;
            board(middlerow:row+middlerow-1, middlecol:col+middlecol-1,:) = icons(ind).img;
             
        end
    end
end
figure('Color', 'w'); 
imshow(board);
