function P = est_board_transform(squares)
img_xy = zeros(numel(squares)*4, 2);
ideal_xy = zeros(numel(squares)*4, 2);
for isquare = 1:numel(squares)
    inds = (isquare-1)*4 + (1:4);
    img_xy(inds, :) = squares(isquare).corners;
    ideal_x = [0; 1; 0; 1] + squares(isquare).rel_x;
    ideal_y = [0; 0; 1; 1] + squares(isquare).rel_y;
    % ideal_xy = [0, 0; 1, 0; 0, 1; 1, 1];
    ideal_xy(inds, :) = [ideal_x, ideal_y];
end
[~, u_inds] = unique(ideal_xy, 'rows');
ideal_xy = ideal_xy(u_inds, :);
img_xy = img_xy(u_inds, :);

P = calc_transform(img_xy(:, 1), img_xy(:, 2), ideal_xy(:, 1), ideal_xy(:, 2));
