function img_gray = filter_background(img_gray, squares,buffsize,color)

board_corners = [squares(1, 1).corners(4, :);
    squares(1, 8).corners(3, :);
    squares(8, 1).corners(2, :);
    squares(8, 8).corners(1, :)];
inds = [3, 1; 4, 3; 2, 1; 4, 2];
buffer = [buffsize, Inf; Inf, buffsize; buffsize, Inf; Inf, buffsize];
%buffer = [ Inf, buffsize; buffsize, Inf;Inf, buffsize;buffsize, Inf ];
for iside = 1:4
    slope = diff(board_corners(inds(iside, :), 2))/diff(board_corners(inds(iside, :), 1));
    xy = board_corners(inds(iside, 1), :);
    img_gray = keep_area_near_line(slope, xy, img_gray, buffer(iside, :),color);
end
figure; imshow(img_gray, 'InitialMagnification', 'fit');
