clc;clear;close all
%load DataBase_400pts_unambgious; %load workspaceworkspace2;
load DataBase_400pts_new
%% load image data and identify chessboard
img_data = preprocess_img; 
squares = find_board(img_data);
img = img_data.img;
figure;imshow(img)
%% create version of image with red, green, and white set to white
valr=255;
red=img(:,:,1)-img(:,:,2)-img(:,:,3);
red=im2bw(red,graythresh(red));
img(repmat(red,1,1,3))=valr; clear red
green=img(:,:,2)-img(:,:,1)-img(:,:,3);
green=im2bw(green,graythresh(green));
img(repmat(green,1,1,3))=valr; clear green
white=img(:,:,3)-img(:,:,1);
white=im2bw(white,graythresh(white));
img(repmat(white,1,1,3))=valr; clear white
 figure;imshow(img);
%% use different methods to classify pieces, and display the results
[CR_otsu, labels_otsu,numregions_otsu]=Otsu2(img);
[squares_otsu,CR_otsu] = straighten_board(img_data, squares, CR_otsu, labels_otsu);
display_board(squares_otsu);title('Otsu segmentation');

[CR_canny,labels_canny,numregions_canny]=Canny2(img);
[squares_canny,CR_canny] = straighten_board(img_data, squares, CR_canny, labels_canny);
display_board(squares_canny);title('Canny edge detection');

[CR_color,labels_color,numregions_color]=color_detection2(img);
[squares_color, CR_color] = straighten_board(img_data, squares, CR_color, labels_color);
display_board(squares_color); title('Color detection');

num_pcs2=[1,1,1,2,0,1; 0,1,1,1,2,1];       option='mindist';
num_pcs2=sum(num_pcs2);
CR{1}=CR_otsu;  labels{1}=labels_otsu;   numregions{1}=numregions_otsu;
CR{2}=CR_canny;    labels{2}=labels_canny;     numregions{2}=numregions_canny;
CR{3}=CR_color; labels{3}=labels_color;  numregions{3}=numregions_color;

[CR_vote, CR_sideinfo]= vote_sideinfo2(CR,labels,numregions,'majority',num_pcs2);
[squares_vote, CR_vote] = straighten_board(img_data, squares, CR_vote, labels{1});
display_board(squares_vote);title('Mjority');
if ~isempty(num_pcs2)
    [squares_sideinfo, CR_sideinfo] = straighten_board(img_data, squares, CR_sideinfo, labels{1});
    display_board(squares_sideinfo); title('Sideinfo majority');
end

[CR_vote2, CR_sideinfo2]= vote_sideinfo2(CR,labels,numregions,option,num_pcs2);
[squares_vote2, CR_vote2] = straighten_board(img_data, squares, CR_vote2, labels{1});
display_board(squares_vote2); title('Mindist');
if ~isempty(num_pcs2)
    [squares_sideinfo2, CR_sideinfo2] = straighten_board(img_data, squares, CR_sideinfo2, labels{1});
    display_board(squares_sideinfo2); title('Sideinfo mindist');
end
